Subject: bug#61192: Emacs 28.1: Bash Shell Script Indenting does not recognize if, [....];then

From: Stephen Montsaroff <[email-masked]>
Date: Mon, 30 Jan 2023 14:14:32 -0800

Since upgrade to Emacs 28.1, I have noted an annoy change in
shell-script mode auto-formatting.

I would like to recover the old behavior

Before, if I entered

if [ "$x" = "" ];then
     export x=$y
fi

and then enter new line, the new line would align with the fi

if [ "$x" = "" ];then
     export x=$y
fi
cp fred ethel

Now it I do the same thing I get the new line indented

if [ "$x" = "" ];then
     export x=$y
fi
     cp fred ethel

The matching code also does not recognize that the
fi is connected to the then statement.

This is not the case if I break the if into two lines or add a leading
space to the ;

if [ "$x" = "" ]
then
     export x=$y
fi
cp fred ethel

if [ "$x" = "" ];then
     export x=$y
fi
cp fred ethel

In GNU Emacs 28.1 (build 2, x86_64-w64-mingw32)
  of 2022-04-21 built on AVALON
Windowing system distributor 'Microsoft Corp.', version 10.0.19045
System Description: Microsoft Windows 10 Enterprise (v10.0.2009.19045.2130)

Configured using:
  'configure --with-modules --without-dbus --with-native-compilation
  --without-compress-install CFLAGS=-O2'

Configured features:
ACL GIF GMP GNUTLS HARFBUZZ JPEG JSON LCMS2 LIBXML2 MODULES NATIVE_COMP
NOTIFY W32NOTIFY PDUMPER PNG RSVG SOUND THREADS TIFF TOOLKIT_SCROLL_BARS
XPM ZLIB

(NATIVE_COMP present but libgccjit not available)

Important settings:
   value of $LC_CTYPE: en_US.UTF-8
   value of $LANG: ENU
   locale-coding-system: cp1252

Major mode: Lisp Interaction

Minor modes in effect:
   tooltip-mode: t
   global-eldoc-mode: t
   eldoc-mode: t
   show-paren-mode: t
   electric-indent-mode: t
   mouse-wheel-mode: t
   tool-bar-mode: t
   menu-bar-mode: t
   file-name-shadow-mode: t
   global-font-lock-mode: t
   font-lock-mode: t
   blink-cursor-mode: t
   auto-composition-mode: t
   auto-encryption-mode: t
   auto-compression-mode: t
   line-number-mode: t
   indent-tabs-mode: t
   transient-mark-mode: t

Load-path shadows:
None found.

Features:
(shadow sort mail-extr emacsbug message rmc puny dired dired-loaddefs
rfc822 mml mml-sec epa derived epg rfc6068 epg-config gnus-util rmail
rmail-loaddefs auth-source cl-seq eieio eieio-core cl-macs
eieio-loaddefs password-cache json map text-property-search seq byte-opt
gv bytecomp byte-compile cconv mm-decode mm-bodies mm-encode mail-parse
rfc2231 mailabbrev gmm-utils mailheader sendmail rfc2047 rfc2045
ietf-drums mm-util mail-prsvr mail-utils time-date subr-x cl-loaddefs
cl-lib iso-transl tooltip eldoc paren electric uniquify ediff-hook
vc-hooks lisp-float-type elisp-mode mwheel dos-w32 ls-lisp disp-table
term/w32-win w32-win w32-vars term/common-win tool-bar dnd fontset image
regexp-opt fringe tabulated-list replace newcomment text-mode lisp-mode
prog-mode register page tab-bar menu-bar rfn-eshadow isearch easymenu
timer select scroll-bar mouse jit-lock font-lock syntax font-core
term/tty-colors frame minibuffer cl-generic cham georgian utf-8-lang
misc-lang vietnamese tibetan thai tai-viet lao korean japanese eucjp-ms
cp51932 hebrew greek romanian slovak czech european ethiopic indian
cyrillic chinese composite emoji-zwj charscript charprop case-table
epa-hook jka-cmpr-hook help simple abbrev obarray cl-preloaded nadvice
button loaddefs faces cus-face macroexp files window text-properties
overlay sha1 md5 base64 format env code-pages mule custom widget
hashtable-print-readable backquote threads w32notify w32 lcms2 multi-tty
make-network-process native-compile emacs)

Memory information:
((conses 16 60127 6905)
  (symbols 48 7062 1)
  (strings 32 21734 2167)
  (string-bytes 1 718164)
  (vectors 16 14999)
  (vector-slots 8 258735 12590)
  (floats 8 23 303)
  (intervals 56 228 0)
  (buffers 992 10))